program fotohtml(input, output);
{
 Prepare an HTML format file to display fotos with a Web browser
 using as file the .txt file for which the root of the file name
 is supplied (which may be the first parameter to the program).

 (fileroot).htm is created as the first file in a set that display
  the photo images in a Web browser such as Netscape or Internet
  Explorer or Opera. The program uses a limit of (for example)
  10 photo images then creates a new HTML page. These page files
  are numbered sequentially and have a "next" button. The program
  originally created one large HTML file, but this can be very
  slow to load and can overburden computer memory handling.

  The program scales the photo images so each one will fit nicely
  on the display screen. (We assume an 800*600 resolution. Note 
  that the scaling could be altered in the source code.) 

 WARNING: This program is designed only to handle SHORT file names
 in the 8.3 format, so it is a good idea to use a SHORT (e.g., 5
 or 6 character) filename root.

 File MISSING.TXT is created if any names in the (fileroot).txt
 file are NOT in the working (current) directory, or if there
 are image files *.bmp, *.gif, *.jpg.

  Program written in Turbo Pascal 5.0 by John C. Nash  October 1999.
  Revised to put 10 photos per html page, March 2001.
  Copyright (C) John C. Nash 1999, 2001
  J C Nash, 1975 Bel Air Drive, Ottawa, K2C 0X1 Canada

  Permission granted for use of this program without charge providing
  that the author is acknowledged in any report, publication, software
  or other record of use.

  Program will complain about missing or read-only image files. (They
  MUST be in the working directory).

}

uses dos, crt;

type
  str12 = string[12];
  str2  = string[2];
  str19 = string[19];

const
  maxfn    = 1000;  {Maximum files in 1 directory}
  fotopg   = 10;    {number of photos per html file}
  special = ReadOnly or Hidden or SysFile;

var
  ntxt, nbak, dtxt, dbak, htxt, hbak: byte;
  stxt, sbak, rtxt, rbak, ltxt, lbak: byte;
  cc: integer; {counter}
  dirpos:  integer; {number of file at #1 position in current display}
  dmask: string;   {search mask}
  fsize : longint;
  fname: string;
  i : word;
  lastderr: integer; {last Dos Error}
  longnams: integer; {counts the number of long name records}
  mm: integer; {number of files to display}
  nprm : integer;
  tstr : string;
  fnams  : array[1..maxfn] of str12;   {file names in directory}
  ffnams : array[1..maxfn] of str12;   {file names in file}
  {?? note -- no long names here}
  fattr  : array[1..maxfn] of byte;    {file attributes ?? why not byte}
  flen   : array[1..maxfn] of longint; {file sizes}
  numfils: integer; {number of files in directory}
  nffils : integer; {number of file names in file}
  totbyte: longint;
  vname: str12; {volid}
  wpath: string;
  numdirs: integer; {number of directories still to search}
  drive: str2;

  {original fotohtml declarations that are not above}
  aline : string;  {to hold a line of text}
  dlett : string[1]; {drive letter}
   line : string;   {data line}
   lline : string;    {last line}
   ifn  : string;      {the input file name}
   ifl    : text;    {the input file variable}
   ofn  : string;      {the list file name}
   ofl    : text;    {the list file variable}
   pstr  : PathStr; {string[79] for path string -- note this may conflict
              with Windows 95/98/nt}
   ll    : integer; {the length of a line}
   j   : integer; {working counters}
   wdn    : string;      {the working directory name}
   foton  : string;  {foto file name}
   mfn    : string; {missing file name}
   mfl    : text;
   mcount : integer; {to count missings}

{@I deblnk.inc}
{********************}
procedure rblank(var myline: string);
{deblank right hand side of string MYLINE}
var
 lml : integer; {length of string}
 last : integer; {last non-blank positions}
begin
 lml := length(myline);
 last := lml;
{$B-}  {This is IGNORED by the Free Pascal Compiler}
 while ((last >=1) and (myline[last] = ' ')) do last := last-1;
 {Note: MUST short-circuit the boolean evaluation in case myline is null}
 if lml>last then delete(myline,last+1,lml-last);
end; {rblank}
{********************}
procedure lblank(var myline: string);
{deblank left hand side of string MYLINE}
var
 lml : integer; {length of string}
 first : integer; {first non-blank positions}
begin
 lml := length(myline);
 first:=1;
{$B-}  {This is IGNORED by the Free Pascal Compiler}
 while ((first <= lml) and (myline[first] = ' ')) do first := first+1;
 {Note: MUST short-circuit the boolean evaluation in case myline is null}
 if first>1 then delete(myline,1,first-1);
end; {lblank}
{********************}
procedure deblank(var myline: string);
{removes blanks from both ends of string }
begin
 rblank(myline);
 lblank(myline);
end; {Deblank}
{********************}
procedure nonobeep;
{beep for error}
begin
  sound(300);
  delay(100);
  sound(100);
  delay(200);
  nosound;
end; {beep}

procedure closefl;
begin
  close(ifl);
(*
  flush(ofl);
  close(ofl);
*)
  flush(mfl);
  close(mfl);
end; {closefl}
{********************}
{******************************************************}
procedure upper(var onename: string);
{convert a string to uppercase}
var
  onechar : char;
  sl: integer;
  i: integer;

begin
  sl:=length(onename);
  if sl>0 then 
  begin
    for i:=1 to sl do
    begin
      onechar:=onename[i];
      onechar:=upcase(onechar);
      onename[i]:=onechar;
    end;
  end; {if sl>0}
end; {upper}
{******************************************************}



function filexist(fname: string): boolean;
{returns TRUE if named file exists}
{Globals used: none
Calls made:
  ST: pushhist	pophist
  SYSTEM: assign close IOResult reset
}
var
  temfile: file; {temporary file}
begin
  {$I-}
  assign(temfile, fname);
  reset(temfile); {open temporary file for input}
  close(temfile);
  {$I+}
  filexist:=(IOResult = 0) and (fname<>''); {successful open/close of
    temp file and non-null name}
end; {filexist} {returns TRUE if named file exists}
{=========}
function quickYN(default : char):boolean;
{ Read string response to question and returns TRUE if a [cr] or upper
  case form of the first character is identical to the default;
  FALSE otherwise.  No check for silly responses.
}
{NOTE: trych is LOCAL}
{Globals used: none
Calls made:
  ST:
	pushhist
	pophist
  SYSTEM:
  	upcase
  WINCRT:
  	readkey
}
var
  trych : char; {input character}
begin
  default:=upcase(default);
  trych:=upcase(readkey); {this converts user input to upper case}
  if trych=chr(13) then trych := default; {[cr] means use default}
  if trych=default then quickYN:=TRUE else quickYN:=FALSE;
end; {quickYN}
{======}  {returns TRUE if [cr] or uppercase default entered}
{===================}
procedure sortfile;
{
  This is a dumb bubblesort. Should be replaced for
  efficiency on LARGE sets of files, but may actually
  be faster for small directories.
}
var
  i,j: integer;
  tname: str12;
  tsize: longint;
  tattr: word;
begin
  {here we sort only by name at the moment??}
  for i:=1 to numfils-1 do
  begin
    for j:=(i+1) to numfils do
    begin
      if fnams[i]>fnams[j] then {presume upper case names??}
      begin {exchange}
        tname:=fnams[j];
        tsize:=flen[j];
        tattr:=fattr[j];
        fnams[j]:=fnams[i];
        flen[j]:=flen[i];
        fattr[j]:=fattr[i];
        fnams[i]:=tname;
        flen[i]:=tsize;
        fattr[i]:=tattr;
      end;
    end; {for j}
  end; {for i}
end; {sortfile}


procedure stuffdir(drek: SearchRec);
{puts a new file entry on the file stack}
var
  i: integer;
begin
  numfils:=numfils+1;
  with drek do
  begin
      for i:=1 to length(name) do name[i]:=upcase(name[i]);
   {010327 -- make names UPPER case. Note that name is string[12]}
      fnams[numfils]:=name;
      fattr[numfils]:=Attr;
      flen[numfils]:=Size;
  end; {with}
end; {stuffdir}
{==================}
{dirget}
procedure dirget(mask:string; Afilter:word);
{get directory of disk in drive pointed to by mask and stuff in arrays fnams}
var
  drec: SearchRec;
  i: integer;
begin
  {$I-}
  findfirst(mask, Afilter, drec);
  {$I+}
  lastderr:=DosError;
  case lastderr of
  0: begin {file OK}
       if (drec.Attr and VolumeID)<>0 then
       begin
         if (
          ((drec.Attr and ReadOnly)<>0) and
          ((drec.Attr and SysFile)<>0) and
          ((drec.Attr and VolumeId)<>0) and
          ((drec.Attr and Hidden)<>0)  and
          ((drec.Attr and Directory) = 0)   ) then
         begin
            longnams:=longnams+1;(* write('!!!!', chr(7)); *)
            {?? can we display the long names}
         end
         else
         begin
            vname:=drec.Name
         end
       end
       else
       begin
         stuffdir(drec);
       end;
     end; {file OK}
  2: begin {Don't bother to do anything with no files found}
     end;
  3: begin
        writeln('Directory not found');
        write('Hit [cr] to end'); readln;
        exit;
      end;
  18: begin
(*        writeln('No files');   *)
      end;
  152: begin
        writeln('Drive not ready');
        write('Hit [cr] to end'); readln;
        halt;  {?? or do we want exit}
      end;
  else begin
         writeln('DosError = ',DosError,' hit Enter to continue');
         readln; exit;
       end;
  end; {case}
  {NOTE: numfils is a global variable.}
  while (lastderr<>18) and (numfils<maxfn) do
  begin
  {$I-}
    findnext(drec); 
  {$I+}
    lastderr:=DosError;
    case lastderr of
    0: begin {file OK}
         if (drec.Attr and VolumeID)<>0 then
         begin
          if (
          ((drec.Attr and ReadOnly)<>0) and
          ((drec.Attr and SysFile)<>0) and
          ((drec.Attr and VolumeId)<>0) and
          ((drec.Attr and Hidden)<>0)  and
          ((drec.Attr and Directory) = 0)   ) then
          begin
            longnams:=longnams+1; (* write('####',chr(7)); *)
          end
          else
            if length(vname)=0 then
              vname:=drec.Name
            else
            begin
              nonobeep;
              writeln('WARNING: >1 VolumeID. ',drec.Name,
                      ' found in path ',wpath);
              readln;
            end;
         end
         else
         begin
           stuffdir(drec);
         end;
       end;
    3: begin {should not be able to get here}
       end;
    18: begin end; {get here after last file}
    152: begin  {should not be able to get here}
         end;
     else begin
            writeln('DosError = ',DosError,' hit Enter to continue');
            readln;
          end;
     end; {case}
   end; {while lastderr}
   if numfils>=maxfn then
   begin
     gotoXY(1,23); clreol;
     writeln(chr(7),'More than ',maxfn,' files in directory');
     writeln('Please rearrange your disk storage and try again');
     write('Hit [Enter] to quit'); readln; halt;
   end;
end; {dirget}

procedure htmtop(var ofl: text; ofn: string; hstring: string);
{Assumes text file ofl is NOT open.
 Opens file and outputs HTML file top bits to this file.}

 begin
  assign(ofl, ofn);
  rewrite(ofl);
  {Files now open -- begin}
  writeln(ofl,'<HTML>');
  writeln(ofl,'<HEAD>');
  writeln(ofl,'<TITLE>',ofn,'</TITLE>');
  writeln(ofl,'</HEAD>');
  writeln(ofl,'<BODY>');
  writeln(ofl,'<H2>',hstring,'</H2>');
  writeln(ofl,'<BR><BR>');
  writeln(ofl,
   '<h3>File created with program fotohtml (C) J C Nash, 1999</h3>');
  writeln(ofl,'<BR><BR>');
end; {htmtop}

procedure htmend(var ofl: text; fname: string);
{Assumes text file ofl is open.
 Outputs HTML file end bits to this file, and closes file.}
begin
  writeln(ofl,'<BR><HL><BR><BR>');
  writeln(ofl,'<A HREF="',fname,'">Next file</A>');
  writeln(ofl,'<BR><HL><BR><BR>');
  writeln(ofl,'</BODY>');
  writeln(ofl,'</HTML>');
  flush(ofl); {to write any buffered info to file}
  close(ofl);
end; {htmend}


var
  fcount: integer; {file counter}
  filedone: boolean;
  fword: word; {filter word for file directory}
  ii,jj,kk: integer;
  havefile: boolean; {TRUE when a good file is found}
  hsave: string;   {main header string for set of files}
  hstring: string; {header string for file}
  inpath: string;
  dnum: byte; {drive number}
  dchar: char; {drive letter}
  fextn: str12;
  fnroot: str12;
  framnum: integer;
  hname: string;
  keepon: boolean;
  nfoto: integer; {to count fotos ?? needed??}
  oldtext: byte;
  tfnam: string; {temporary filename}
  tfile: text;
  tline: string;
  tpath: string;  {temporary path}
  spath: string; {path BEFORE current directory set}
  vrec: SearchRec;

begin {MAIN}
  writeln('fotohtml -- (C) J C Nash 1991');
  if paramcount=0 then {if no command line parameters, then display a
                        message about the program}
  begin
    writeln('This program was written by John C. Nash');
    writeln('     1975 Bel Air Drive, Ottawa, Ontario, K2C 0X1');
    writeln('       jcnash@uottawa.ca');
    writeln;
    writeln('Usage:');
    writeln('     fotohtml myfile');
    writeln('creates HTML version of photo lists from file myfile.txt');
    writeln('  to the file myfile.htm');
    writeln('This version puts a maximum of 10 images in each HTML file');
    writeln('with a "NEXT" button on the HTML page.');
    writeln;
    write('Root for file name ='); readln(ifn);
  end
  else  ifn:=paramstr(1);
  deblank(ifn);
  pstr:=ifn+'.txt';
  pstr:=fexpand('pstr'); {expand the filename}
  dlett:=copy(pstr,1,1);
  fnroot:=ifn;
  ifn:=ifn+'.txt';
  mfn:='missing.txt';
  if filexist(mfn) then
  begin
    write('Missing.txt EXISTS -- Overwrite ([cr]=N) ');
    if QuickYN('N') then
    begin
      writeln(chr(7),'Stopping -- do not want to overwrite file');
      halt; {This may not work well on some systems.}
    end
  end;
  assign(mfl,mfn);
  rewrite(mfl);
  mcount:=0;
  if not filexist(ifn) then
  begin
    write(chr(7),'ERROR -- file does not exist');
    halt;
  end;
  assign(ifl,ifn);
  reset(ifl);
  writeln('File : ',ifn,' OPEN FOR INPUT');
  if filexist(ofn) then
  begin
    write(chr(7),'WARNING -- file:',ofn,' exists, Overwrite ([cr]=N)');
    if quickyn('N') then
    begin
      close(ifl); flush(mfl); close(mfl);
      halt;
    end;
  end;
{Now get file names of image files}
  longnams:=0;
  numfils:=0; {set number of files to 0 to start}
  vname:=''; {start with null volume name}
  totbyte:=0;
  oldtext:=textattr;
  nprm:=paramcount; { use current directory }
  tstr:='';
  havefile:=false;
  keepon:=true;
  fword:= AnyFile; { $3F all 1s in mask}
  wpath:='.\'; {Save inpath as given, just in case}
  deblank(wpath);{remove blanks, in case code changed}
  tstr:=wpath[length(wpath)]; {last nonblank character}
  dmask:=fexpand(wpath+'*.jpg');
  dirget(dmask,fword); {loads directory in fnams[] and fattr
                          and sets numfils}
  writeln(numfils,' JPG files');
  i:=numfils;
  dmask:=fexpand(wpath+'*.gif');
  dirget(dmask,fword); {loads directory in fnams[] and fattr
                          and sets numfils}
  writeln(numfils-i,' GIF files');
  i:=numfils;
  dmask:=fexpand(wpath+'*.bmp');
  dirget(dmask,fword); {loads directory in fnams[] and fattr
                          and sets numfils}
  writeln(numfils-i,' BMP files');
  {Now process them}
  if (numfils>0) and (lastderr=18) then lastderr:=0;
  case lastderr of
  0: begin
(*
       if numfils>0 then
       begin {call the sort}
         sortfile;
       end; 
 *)
     end; {case lastderr=0}
  3: tstr:='Directory not found';
  18: tstr:='No files found -- Try again';
  152: tstr:='Drive not ready -- please check it';
  else begin
         str(lastderr,tstr);
         tstr:='Unrecognized DOS Error #'+tstr;
         writeln('Hit [Enter] to continue'); readln;
       end;
  end; {case}
  {sort the files}
  sortfile;
  {Get file names from file}
  nffils:=0; {set to 0 initially}
  reset(ifl);
  {Files now open -- begin}
  readln(ifl,aline); {the title and header}
  {find first non null line}
  while not eof(ifl) do
  begin
    readln(ifl,line);
    deblank(line);
    if not ((ll<0) and (length(line)=0) ) then {NOT at top of file}
    begin
      if length(line)=0 then
      begin {write end of photo material}
      end
      else
      begin {line not null}
        if ll<1 then {we are on a "first" line, so output name}
        begin
          i:=pos(' ',line);
          foton:=copy(line,1,i-1);
          upper(foton);
          nffils:=nffils+1;
          ffnams[nffils]:=foton;
        end;
      end; {line not null}
      ll:=length(line); {and save length}
    end; {Not at top of file}
  end; {while loop}
  close(ifl);
  {Process lists and prepare "missing" file}
  {Compare and report}
  writeln(numfils,' Image files in directory');
  writeln(mfl,'Image files in directory but not in caption file:');
  kk:=0; {counter}
  for i:=1 to numfils do
  begin
    tstr:=fnams[i];
    j:=1; {counter for files in captions file}
    while ( (j<=nffils) and (tstr<>ffnams[j]) ) do
    {?? NOTE: do not seem to be able to use <, so no use sorting}
    begin
      j:=j+1;
    end;
    if j>nffils then
    begin   {file not found}
      writeln(mfl,tstr,' Not found');
(*      writeln(tstr,' Not found');  *)
      kk:=kk+1;
    end
    else
    begin {file found -- do nothing}
    end;
  end;
  writeln('   Total of ',kk,' files not found');
  writeln(mfl,'   Total of ',kk,' files not found');
  writeln(mfl);
  writeln(mfl,'File names in caption file but not in directory:');
  writeln(nffils,' File names in caption file');
  mcount:=kk;
  kk:=0; {counter}
  for i:=1 to nffils do
  begin
    tstr:=ffnams[i];
    j:=1; {counter for files in captions file}
    while ( (j<=numfils) and (tstr<>fnams[j]) ) do
    begin
      j:=j+1;
    end;
    if j>numfils then
    begin   {file not found}
      writeln(mfl,tstr,' Not found');
(*      writeln(tstr,' Not found');  *)
      kk:=kk+1;
    end
    else
    begin {file found -- do nothing}
    end;
  end;
  writeln('   Total of ',kk,' files not found');
  writeln(mfl,'   Total of ',kk,' files not found');
  writeln(mfl); writeln;
  mcount:=mcount+kk; {both sets of missings are important}
  writeln('Total of ',mcount,' unreconciled filenames');
  if mcount>0 then
  begin
    write('Hit [Enter] to continue'); readln;
  end;  
  {Now process main file}
  reset(ifl);
  filedone:=false; {so far file is not done}
  fcount:=1; {file counter}
  readln(ifl,aline); {the title and header}
  hsave:=aline; {Save the header -- will add a numeric counter}
  repeat  {until no more lines in input file}
    if fcount>1 then
    begin
      str(fcount, tstr);
      deblank(tstr);
      ofn:=fnroot+tstr+'.htm';
      hstring:=hsave+'  part '+tstr;
    end
    else
    begin
      hstring:=hsave;
      ofn:=fnroot+'.htm';
    end;
    htmtop(ofl, ofn, hstring); {file open and header in place}
    writeln(ofl,'<UL>');
    ll:=-1; {length last}
    nfoto:=0; {initialize foto count in set}
    {find first non null line}
    {?? must get ALL of caption !!!
    Problem: nfoto gets to 10, but caption NOT finished.

    }
    while (not eof(ifl) and (nfoto<fotopg)) do
    begin
      readln(ifl,line);
      deblank(line);
      if not ((ll<0) and (length(line)=0) ) then {NOT at top of file}
      begin
        if length(line)=0 then
        begin {write end of photo material}
           writeln(ofl,'<BR><BR></LI>');
     (*    writeln('<BR><BR></LI>');  *)
           nfoto:=nfoto+1;
        end
        else
        begin {line not null}
          if ll<1 then {we are on a "first" line, so output name}
          begin
            i:=pos(' ',line);
            foton:=copy(line,1,i-1);
            writeln(ofl,'<LI><IMG Height=380 align=top SRC="');
            writeln(ofl,foton,'"><BR>',line);
          end
          else {write out 2nd or subsequent line}
          begin
            writeln(ofl,line);
          end;
        end; {line not null}
        ll:=length(line); {and save length}
      end; {Not at top of file}
    end; {while loop over lines}
    writeln(ofl,'</UL>'); {to end the list of fotos}
    str(fcount+1, tstr);
    deblank(tstr);
    write(ofn,' ');
    if 6*(fcount div 6) = fcount then writeln;
    ofn:=fnroot+tstr+'.htm';
    htmend(ofl,ofn); fcount:=fcount+1;
    if eof(ifl) then filedone:=true;
  until filedone;
  str(fcount, tstr);
  deblank(tstr);
  ofn:=fnroot+tstr+'.htm';
  hstring:='last file';
  htmtop(ofl, ofn, hstring); {file open and header in place}
  writeln(ofl,'<H3>This photo collection displayed using</H3>');
  writeln(ofl,'<center><H2>FOTOHTML</H2></center>');
  writeln(ofl,'<H3>J C Nash (C) 1999, 2001</H3>');
  writeln(ofl,
    '<H3><A HREF="http://www.nashinfo.com">www.nashinfo.com</A></H3>');
  writeln(ofl,'</BODY>');
  writeln(ofl,'</HTML>');
  flush(ofl); {to write any buffered info to file}
  close(ofl);


  closefl;
  if mcount=0 then erase(mfl);
  {?? how to handle extra blank lines at end}
  

end. {fotohtml}
